<?php

// this is a CLI & needs: $ sudo apt-get install php5-cli

function XOREncryption($InputString, $KeyPhrase){
    $KeyPhraseLength = strlen($KeyPhrase);
    // Loop trough input string
    for ($i = 0; $i < strlen($InputString); $i++){
        // Get key phrase character position
        $rPos = $i % $KeyPhraseLength;
        // Magic happens here:
        $r = ord($InputString[$i]) ^ ord($KeyPhrase[$rPos]);
        // Replace characters
        $InputString[$i] = chr($r);
    }
    return $InputString;
}

// get a key
// input: 	
//	0 => a key from the file (or backup) for en/decryption
//	1 => a key from the file (or backup) for mac gen/check
//  2 => bakcup key for en/decryption
//  3 => bakcup key for mac gen/check
function getkey($use)
{
	if ($use==0 || $use==1) {
		$keyfile="/data/apps/DTNmailex/etc/pwdenc.key";
		// $keyfile="../etc/pwdenc.key";
		$kfh=fopen($keyfile,"r");
		if (!$kfh) {
		// if no key file fall back to hardcoded key
			$key="mostly77&66*&^%";
		} else {
			$key=fgets($kfh);
			fclose($kfh);
		}
		if ($use==0) { // for a mac
			// just so that you need both the code and the keyfile...
			$xorkey=XORencryption($key,"652437824378924");
		} else { // for enc/dec
			// just so that you need both the code and the keyfile...
			$xorkey=XORencryption($key,"892437892436524");
		}
	} else if ( $use==2 || $use == 3) {
		$key="mostly77&66*&^%";
		if ($use==2) {
			$xorkey=XORencryption($key,"652437824378924");
		} else {
			$xorkey=XORencryption($key,"892437892436524");
		}
	} else {
		return "oops";
	}
	return $xorkey;
}

function domac($file)
{
	// calculate a MAC on the bytes from our key file
	$key=getkey(1);
	$mac=hash_hmac_file("sha256",$file,$key);
	$fh=fopen($file,"a");
	if (!$fh) return(false);
	$ml=strlen($mac);
	fputs($fh,"$mac.$ml\n");
	fclose($fh);
	return true;
}

function domac_backupkey($file)
{
	// calculate a MAC on the bytes from our key file
	$key=getkey(3);
	$mac=hash_hmac_file("sha256",$file,$key);
	$fh=fopen($file,"a");
	if (!$fh) return(false);
	$ml=strlen($mac);
	fputs($fh,"$mac.$ml\n");
	fclose($fh);
	return true;
}

function checkmac($file)
{
	$key=getkey(1);
	// $tmpfile="/tmp/maccheckin";
	$tmpfile="foo.tmp";
	copy($file,$tmpfile);
	exec("tail -1 $tmpfile",$results);
	$macwithlen=$results[0];
	$dotpos=strpos($macwithlen,".");
	$mac=substr($macwithlen,0,$dotpos);
	$len=substr($macwithlen,$dotpos+1);
	$fh=fopen($tmpfile,"r+");
	if (!$fh) return false;
	$tlen=filesize($file)-($len+4);
	ftruncate($fh,$tlen);
	fclose($fh);
	$recalcmac=hash_hmac_file("sha256",$tmpfile,$key);
	// print "recalcmac: $recalcmac \n";
	if (!strcmp($recalcmac,$mac)) {
		unlink($tmpfile);
		return(true);
	}
	// oops - maybe its good with the backup key
	print "Trying backup key\n";
	$key=getkey(3);
	$recalcmac=hash_hmac_file("sha256",$tmpfile,$key);
	// print "\tmacwithlen: $macwithlen\n";
	// print "\ttruncated to $tlen\n";
	// print "\tmac: $mac len: $len\n";
	// print "\trecalcmac: $recalcmac \n";
	unlink($tmpfile);
	if (!strcmp($recalcmac,$mac)) return(true);
	return false;
}

function mydec($cipherstring)
{
	$key=getkey(0);
	$cipher=base64_decode($cipherstring);
	$iv="0123456789abcdef";
	$plain1=mcrypt_decrypt(MCRYPT_RIJNDAEL_128,$key,$cipher,"cbc",$iv);
	// print "\tplain 1: $plain1\n";
	if (!strncmp($plain1,"PASS:",5)) {
		$plain=substr($plain1,5);
		return $plain;
	} 
	// try the backup key
	$key=getkey(2);
	$plain2=mcrypt_decrypt(MCRYPT_RIJNDAEL_128,$key,$cipher,"cbc",$iv);
	// print "\tplain 2: $plain2\n";
	// is output a nice string? if not, try backup key
	if (!strncmp($plain2,"PASS:",5)) {
		$plain=substr($plain2,5);
		return $plain;
	}
	return false;
}

function myenc($plainstring)
{
	$iv="0123456789abcdef";
	$key=getkey(0);
	$cipher=mcrypt_encrypt(MCRYPT_RIJNDAEL_128,$key,"PASS:".$plainstring,"cbc",$iv);
	$b64cipher=base64_encode($cipher);
	return $b64cipher;
}

function myenc_backup($plainstring)
{
	$key=getkey(2);
	$iv="0123456789abcdef";
	$cipher=mcrypt_encrypt(MCRYPT_RIJNDAEL_128,$key,"PASS:".$plainstring,"cbc",$iv);
	$b64cipher=base64_encode($cipher);
	return $b64cipher;
}

function test_mac()
{
	// try out mac gen/check
	$ifile="foo.in";
	$mfile="foo.mac";
	$bfile="foo.badmac";
	$bupfile="foo.bupkey";
	copy($ifile,$mfile);
	domac($mfile);
	copy($ifile,$bupfile);
	domac_backupkey($bupfile);
	$rv=checkmac($mfile);
	if ($rv) print "good mac for $mfile\n";
	else print "bad mac for $mfile\n";
	if (file_exists($bfile)) {
		$rv=checkmac($bfile);
		if ($rv) print "good mac for $bfile\n";
		else print "bad mac for $bfile\n";
	}
	if (file_exists($bupfile)) {
		$rv=checkmac($bupfile);
		if ($rv) print "good mac for $bupfile\n";
		else print "bad mac for $bupfile\n";
	}
	if (file_exists($mfile)) unlink($mfile);
	if (file_exists($bfile)) unlink($bfile);
	if (file_exists($bupfile)) unlink($bupfile);
}

function test_enc()
{
	print "\nMain test\n";
	$plain="this is a test plain";
	$cipher=myenc($plain);
	$recplain=mydec($cipher);
	if (!$recplain) {
		print "Oops: plain: |$plain|\n";
		print "Oops: cipher: |$cipher|\n";
		print "Oops: recplain: |$recplain|\n";
	} else {
		if (!strncmp($plain,$recplain,strlen($plain))) {
			print "Enc/Dec fine.\n";
		} else {
			print "plain: |$plain|\n";
			print "cipher: |$cipher|\n";
			print "recplain: |$recplain|\n";
		}
	}
	print "\nBackup test\n";
	$cipher1=myenc_backup($plain);
	$recplain1=mydec($cipher1);
	if (!$recplain1) {
		print "Oops: plain: |$plain|\n";
		print "Oops: cipher: |$cipher1\n";
		print "Oops: recplain: |$recplain1|\n";
	} else {
		if (!strncmp($plain,$recplain1,strlen($plain))) {
			print "Backup Enc/Dec fine.\n";
		} else {
			print "plain: |$plain|\n";
			print "cipher: |$cipher1|\n";
			print "recplain: |$recplain1|\n";
		}
	}
}

// test_mac();
// test_enc();

?>
