#!/bin/bash
 
# dtnmailex-listenmail.sh
#
# Written for N4C Summer Trials
# Eoin Meehan May 2009
#r
# This script runs constantly listening for incoming email bundles

# First check if I'm running already - if so exit and do nothing
# Need to set the path for some reason ...

PATH=$PATH:/usr/sbin

PID=$$
LOCKFILE='/etc/dtnmailex/dtnmailex-listenmail.lock'

if [ -f $LOCKFILE ]; then
	lockfilepid=`cat $LOCKFILE`
	ps -fp $lockfilepid > /dev/null && exit	# is this pid already running? If so exit ...
fi

# If we're here we were not running.	
# Remember out PID to the lockfile

echo $$ > $LOCKFILE

echo "dtnmailex-listenmail.sh started"

MAIL_DIR=/var/spool/dtnmailex/fromdtn
 
# Exit codes from <sysexits.h>
EX_TEMPFAIL=75
EX_UNAVAILABLE=69

# Clean up when done or when aborting.
#trap "rm -f out.$$" 0 1 2 3 15
 
# Start processing.

cd $MAIL_DIR || {
     echo $MAIL_DIR does not exist; exit $EX_TEMPFAIL; }

# Fire up dtnrecv to listen for incoming email bundles. Process 1 at a time to prevent loss 
# -N is dont try to use existing registration

while [ 1 ]; do				# ie forever

	mailfile=`date +%Y%m%d%H%S.%N`	# generate unique mailfile

	dtnrecv -n 1 -N -o $mailfile dtn://pixel2.dtn/mailtovillage || {
			echo "Error invoking dtnrecv to receive mails";
			exit $EX_TEMPFAIL; }

	echo "------------- Begin Mail Processing -------------"
	date

	echo "Received "$mailfile" ... looking in "$MAIL_DIR" to process"

		if [ -f $mailfile ] ; then
		    echo "Found $mailfile ... invoking sendmail ..."

		    sendmail -t < $mailfile || {
				echo "Error invoking sendmail";
				exit EX_TEMPFAIL; }

#		    rm $MAIL_DIR/$mailfile || echo "No mail file found" $mailfile
		    echo "Mail sent."
		else
		    echo "Warning - cannot find mailfile "$mailfile
		fi
	echo "------------- End Mail File Processing ----------"

done

exit $?

