<?php

// The key file ../etc/pwdenc.key needs to exist, get it from enc.tar.enc
// The data directory /data/dtn/mailaccounts needs to exist

include 'amcrypt.php';

function check_inputs($emailaddress,$username,$password,$fullname,$otheraddress)
{
	// more checks later no doubt
	if (!isset($username) || $username == "") { 
		print "<h2>Oops!</h2>";
		print "<p>Username is empty. <a href='/mailsignup/'>Start Over</a>"; 
		return(false);
	}
	// characters in input 
	if (ereg('[^A-Za-z0-9.]', $username)) {
		print "<h2>Oops!</h2>";
		print "<p>Bad input somewher. <a href='/mailsignup/'>Start Over</a>"; 
  		print "<p>Username contains characters other than letters, numbers and dots.</p>";
		return(false);
	}
	if (!isset($password) ||  $password == "") {
		print "<h2>Oops!</h2>";
		print "<p>Password is empty. <a href='/mailsignup/'>Start Over</a>"; 
		return(false);
	}
	// more checks on email , if necessary
	$emptyesc=escapeshellarg("");
	if (strlen($otheraddress)==0 || $otheraddress==$emptyesc)  return(true);
	$atpos=strpos($otheraddress,'@');
	if ($atpos === false || $atpos == 0) {
		print "<h2>Oops!</h2>";
		print "<p>Other email address ($otheraddress) looks bad. (no '@' or local part)  <a href='/mailsignup/'>Start Over</a>"; 
		return(false);
	}
	$domain=substr($otheraddress,$atpos+1);
	$dotpos=strpos($domain,'.');
	if ($dotpos === false || $dotpos>=(strlen($domain)-2)) {
		print "<h2>Oops!</h2>";
		print "<p>Other email address looks bad. (bad or no '.' after '@') <a href='/mailsignup/'>Start Over</a>"; 
		// print "<p>$emailaddress, $domain, $atpos, $dotpos</p>";
		return(false);
	}
	return(true);
}

function check_uniq($emailaddress) 
{
	$dirname="/data/dtn/mailaccounts/";
	$filename = $dirname . $emailaddress;
	if (file_exists($filename)) return(false);
	$dirname="/data/dtn/mailaccounts/exceptions";
	$filename = $dirname . $emailaddress;
	if (file_exists($filename)) return(false);
	$dirname="/data/dtn/mailaccounts/processed";
	$filename = $dirname . $emailaddress;
	if (file_exists($filename)) return(false);
	else return(true);
}

function create_account($emailaddress,$username,$password,$fullname,$otheraddress)
{
	$haderror=false;

	exec("hostname",$results);
	$hostname=$results[0];

	$notinvillage=true;
	
	exec("dnsdomainname",$dresults);
	$thisdomain=$dresults[0];
	// print "The domain is: |$thisdomain|\n";
	if ( $thisdomain === false || strlen($thisdomain)==0 || strcmp($thisdomain,"village.n4c.eu")) {
		// we're not in the village, so we just drop the file for manual
		// intervention and don't action account creation.
		$dirname="/data/dtn/mailaccounts/exceptions/";
		$filename=$dirname . $emailaddress;
	} else {
		$dirname="/data/dtn/mailaccounts/";
		$filename = $dirname . $emailaddress;
		$notinvillage=false;
	}

	$fh = fopen($filename,"w");
	if ($fh==false) return(false);
	fputs($fh,"$emailaddress\n");
	fputs($fh,"$username\n");
	$encpass = myenc($password);
	fputs($fh,"$encpass\n");
	fputs($fh,"$fullname\n");
	fputs($fh,"$otheraddress\n");
	$creationdate=date(DATE_ATOM);
	fputs($fh,"$hostname: $creationdate\n");
	fclose($fh);
	domac($filename);

	if ($notinvillage) {
		return 2;
	}


	$seid="dtn://".$hostname.".dtn/mailsignup";
	$deids=array("dtn://n4crouter-1.dtn/addmailaccount",
			"dtn://basil.dsg.cs.tcd.ie.dtn/addmailaccount");
	$ndeids=count($deids);

	$expiry=3600*24*7; // 1 week ok?

	for ($i = 0 ; $i != $ndeids; $i++) {
		// TODO: Detect an error in dtnsend!
		$command="dtnsend -s " . $seid . " -d " . $deids[$i] . " -e " . $expiry . " -t f -p ". $filename;
		$dtnsendoutput=system($command);
		// print "<p>|$dtnsendoutput|</p>";
	}


	if ($haderror) {
		// clean up - don't want to lock them out
		if (file_exists($filename)) unlink($filename);
	}
	return(1);
}

?>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<title>SAIL Summer 2011 Trial - Mail Account Signup</title>
</head>
<body>

<h1><img alt="Logo" src="/images/sail-logo.png" width="243" height="52" /> SAIL Summer
2011 Trial - Mail Account Signup</h1>
<table border="0" width="100%">
</tbody>
<tr>
<td width="20%">
<p><a href="/index.html">Home</a></p>
</td>
<td width="80%">
<p style="text-align:right;margin-left:auto;margin-right:0;">
English, Swenska, Saami, Deutsche</p>
</td>
</tr>
</tbody>
</table>

<?php
	$stage = $_REQUEST['stage'];
	$username = $_REQUEST['username'];
	$password = $_REQUEST['password'];
	// $fullname = filter_input(INPUT_POST,'fullname',FILTER_SANITIZE_SPECIAL_CHARS);
        $fullname =  $_REQUEST['fullname'];
	$otheraddress = filter_input(INPUT_POST,'otheraddress',FILTER_SANITIZE_EMAIL);
	// $otheraddress = escapeshellarg($otheraddress);


	if (!isset($stage)) {
		?>

<p>Please fill in the form below to create a mail account for use 
in the SAIL summer 2011 trial. If you want to be informed before
we delete the mail accounts after the trial, please include
another email address so we can contact you then.</p>

<p>Note that your username is not your email address. For example,
if you pick "fred" then your email address will be something
like "fred-r1@village.n4c.eu". This is to avoid name collisions
if accounts are created from remote sites. After you fill in
the form, the actual email address will be displayed.</p>

<p>Please only use alphanumeric characters ("A-Za-Z0-9") in your username, ("."
is also allowed) as that prevents problems with some email clients.</p> 

<p>Please do not use a sensitive password (e.g. your
paypal password). While we do take care with password
handling, storing them in encrypted form, this is an 
unmanaged experimental system, so passwords stored in
the system are potentially always vulnerable. Best is
to make up a password just for this. If you forget
that, and have supplied us with another email address,
you need to send us an email us at help@village.n4c.eu and
ask for a manual reset.  </p>

<p>Instructions for configuring your email client
to use this mail account may be found on our
<a href="/index.html">home page</a>.</p>

<form name="signup" action="/mailsignup/" method="post">
<table border="1">
<tbody>
	<input type="hidden" name="stage" value="zero"/>
	<tr>
		<td>User name (e.g. "fred")</td>
		<td><input type="text" name="username" /></td>
	</tr>
	<tr>
		<td>Password</td>
		<td><input type="password" name="password" /></td>
	</tr>
	<tr>
		<td>Full Name (e.g. "Fred Flintstone")</td>
		<td><input type="text" name="fullname" /></td>
	</tr>
	<tr>
		<td>Other Email address (optional, e.g. "fred.flintstone001@gmail.com")</td>
		<td> <input type="text" name="otheraddress" /></td>
	</tr>
	<tr>
		<td/>
		<td><input type="submit" value="Submit"/> </tr>
	</tr>
</tbody>
</table>
</form>

<p/>

<?php
	} else if ($stage == "zero") {
		exec("hostname",$results);
		$extender=$results[0];
                $extender=str_replace("n4crouter-","r",$extender);

		if (strncmp($extender,"basil.dsg.cs.tcd.ie",strlen("basil.dsg.cs.tcd.ie"))) {
			$emailaddress = $username."-".$extender."@village.n4c.eu";
		} else { // on basil, no extender
			$emailaddress = $username . "@village.n4c.eu";
		}
		// print "<p>stage: $stage </p>";

		// check inputs
		if (!check_inputs($emailaddress,$username,$password,$fullname,$otheraddress)) {
			exit;
		}
		// check uniqueness
		if (!check_uniq($emailaddress)) {
			print "<h2>Oops!</h2>";
			print "<p>That email address ($emailaddress) is in use. <a href='/mailsignup/'>Start Over</a>"; 
			exit;
		}
		
		print "<h2>Your Mail account details:</h2>";
		print "<p>Email address: $emailaddress </p>";
		print "<p>Full name: $fullname </p>";
		if ($otheraddress != "") print "<p>Other Email Address: $otheraddress </p>";

		print "<form name='confirm' action='/mailsignup/' method='post'>";
		print "<input type='hidden' name='stage' value='one'/>";
		print "<input type='hidden' name='username' value='$username'/>";
		print "<input type='hidden' name='password' value='$password'/>";
		print "<input type='hidden' name='fullname' value='$fullname'/>";
		print "<input type='hidden' name='otheraddress' value='$otheraddress'/>";
		print "<input type='hidden' name='emailaddress' value='$emailaddress'/>";
		print "<input type='submit' name='goahead' value='ok'/>";
		print "</form>";
		print "<form name='redo' action='/mailsignup/' method='post'>";
		print "<input type='submit' name='redo' value='re-do'/>";
		print "</form>";

	} else if ( $stage == "one" ) {
		$postedemailaddress = $_REQUEST['emailaddress'];
		exec("hostname",$results);
		$extender=$results[0];
                $extender=str_replace("n4crouter-","r",$extender);

		if (strncmp($extender,"basil.dsg.cs.tcd.ie",strlen("basil.dsg.cs.tcd.ie"))) {
			$emailaddress = $username."-".$extender."@village.n4c.eu";
		} else { // on basil, no extender
			$emailaddress = $username . "@village.n4c.eu";
		}
		if (strncmp($postedemailaddress,$emailaddress,strlen($emailaddress))) {
			print "<h2>Oops!</h2>";
			print "<p>Internal error. (code=0x987f) <a href='/mailsignup/'>Start Over</a>"; 
			exit;
		}
		// check inputs
		if (!check_inputs($emailaddress,$username,$password,$fullname,$otheraddress)) {
			print "<h2>Oops!</h2>";
			print "<p>Internal error. (code=98ascf) <a href='/mailsignup/'>Start Over</a>"; 
			exit;
		}
		// check uniqueness again
		if (!check_uniq($emailaddress)) {
			print "<h2>Oops!</h2>";
			print "<p>That email address ($emailaddress) has just been used up. <a href='/mailsignup/'>Start Over</a>"; 
			exit;
		}
		// create account
		$carv=create_account($emailaddress,$username,$password,$fullname,$otheraddress);
		if ($carv != 1 && $carv !=2 ) {
			print "<h2>Oops!</h2>";
			print "<p>Error creating account. (abend 4032) <a href='/mailsignup/'>Start Over</a>"; 
			exit;
		}
		if ($carv == 1) {
			print "<p>Your mail account ($emailaddress) has been created and a welcome message has been sent to ";
			print "you there";
			if (strlen($otheraddress)) {
				print " and at your other address ($otheraddress).</p>";
			} else {
				print ".<p>";
			}
			print "<p><a href='/squirrelmail/'>Click here</a> to access your web mail account or go to our ";
			print "<a href='/index.html'>home page</a> for instructions for how to configure your email client. ";
			print "Or you can create another account by going <a href='/mailsignup/'>here</a></p>";
			print "<p/>";
                	print "<p>Note that mail from the Internet can not be delivered until your mail account ";
                	print "has been created on our Internet gateway, which could take some time, depending on ";
                	print "where you were when you created the account and helicopter schedules. If someone ";
                	print "sends an email to this account before it has been created on our Internet gateway ";
                	print "that mail will be returned with an error message saying that the account doesn't ";
                	print "exist. If the sender re-tries later (maybe up to a few days later) then it should work.";
                	print "In the meantime, you can send and receive locally, since the account does exist here. ";
                	print "If you created the account from the Internet or Ritsem, this should not be a problem, ";
                	print "your account will be activated in a few minutes.</p>";
			print "<p/>";
			print "<p>Note also that we do not accept outbound mail for this account from the Internet. ";
			print "Doing so would potentially allow us to become a channel for spam messages.</p>";
			print "<p/>";
			print "<p>And finally - be sure to include the village.n4c.eu domain part of your account ";
			print "name when you configure your IMAP and SMTP options in your email client.</p>";
		} 

		if ($carv==2) {
			print "<p>Since you are not currently in the trial region, we have to manually ";
			print "create your account. We'll send a mail to the account  ";
			print "($emailaddress) ";
			if (strlen($otheraddress)) {
				print " and your other address ($otheraddress) ";
			}
			print "once that has happened. Sorry for being slow, but we have to ";
			print "protect against potential bad actors who might want to send spam.<p>";
			print "<p/>";
			print "If you think that's taking too long, please send a mail to us ";
			print "at help@village.n4c.eu</p>";
		}

	} else {
		// print "<p>stage: $stage</p>";
		print "<p>Error in script. <a href='/mailsignup/'>Start Over</a></p>";
	}
	
?>

</body>
</html>

