#! /usr/bin/php5
<?php

// manuall add a mail account from a file in exceptions
// run this as: $ sudo php5 ./manproc.php

include 'amcrypt.php';

$dirname="/data/dtn/mailaccounts/";
$exceptions="/data/dtn/mailaccounts/exceptions/";
$processed="/data/dtn/mailaccounts/processed/";
exec("hostname",$results);
$hostname=$results[0];
if (!strncmp($hostname,"bench20",strlen("bench20"))) {
	// force it to basil
	$hostname="basil.dsg.cs.tcd.ie";
}
exec("whoami",$wresults);
$user=$wresults[0];

if ($argc!=2) {
	print "Syntax: $ php5 ./manproc.php <filename>\n";
	print "\twhere filename is the name of a file in $exceptions\n";
	exit;
}
$filename=$argv[1];

if (!file_exists($filename)) {
	print "$filename not found. Try somethign else.\n";
	exit;
}

$filebase=basename($filename);
$fullname=$exceptions.$filebase;

if (!file_exists($fullname)) {
	print "$filename is not in the $exceptions directory. Please put it there first.\n";
	exit;
}

if (!file_exists($exceptions) || !is_dir($exceptions)) {
	mkdir($exceptions);
}
if (!file_exists($exceptions) || !is_dir($exceptions)) {
	print "Can't mkdir $exceptions - exiting\n";
	exit;
}

if (!file_exists($processed) || !is_dir($processed)) {
	mkdir($processed);
}
if (!file_exists($processed) || !is_dir($processed)) {
	print "Can't mkdir $processed - exiting\n";
	exit;
}

print "Manually processing $fullname\n";
// ask user, add a new mac and send it on

$fh=fopen($fullname,"r");
if (!$fh) {
	print "Can't open $fullname - exiting\n";
	exit;
}
$emailaddress=rtrim(fgets($fh,4096),"\n");
print "\t$emailddress\n";
while (!feof($fh)) {
	$line=fgets($fh,4096);
	print "\t$line";
}
fclose($fh);

print "Do you want to create this account? [y/N]";
if(!defined("STDIN")) {
	define("STDIN", fopen('php://stdin','r'));
}
$ans = fread(STDIN, 80);

$confirmed=false;
if ($ans[0]=='y' || $ans[0]=='Y') {
	$confirmed=true;
} else {
	print "Ok, I'm outta here. (Nothing was done.)\n";
	exit;
}

if (file_exists($dirname.$emailaddress)) {
	print "There is already an entry for $emailaddress in $dirname\n";
	print "Do you REALLY want to overwrite/reset this account? [y/N]";
	if(!defined("STDIN")) {
		define("STDIN", fopen('php://stdin','r'));
	}
	$ans = fread(STDIN, 80);

	$confirmed=false;
	if ($ans[0]=='y' || $ans[0]=='Y') {
		$confirmed=true;
	} else {
		print "Ok, I'm outta here. (Nothing was done.)\n";
		exit;
	}
}

if ($confirmed) {
	$manfile=$exceptions.$emailaddress;
	copy($fullname,$manfile);
	$fh=fopen($manfile,"a");
	if (!$fh) {
		print "Can't open $manfile - exiting\n";
		exit;
	}
	$mandate=date(DATE_ATOM);
	fputs($fh,"Manual by $user on $hostname at: $mandate\n");
	fclose($fh);
	domac($manfile);
	$procfile=$processed.$emailaddress;
	copy($manfile,$procfile);
	unlink($fullname);

	$seid="dtn://".$hostname.".dtn/mailsignup";
	$deids=array("dtn://n4crouter-1.dtn/addmailaccount",
		"dtn://n4crouter-2.dtn/addmailaccount",
		"dtn://n4crouter-5.dtn/addmailaccount",
		"dtn://basil.dsg.cs.tcd.ie.dtn/addmailaccount");
	$ndeids=count($deids);
	$expiry=3600*24*7; // 1 week ok?
	for ($i = 0 ; $i != $ndeids; $i++) {
		// TODO: Detect an error in dtnsend!
		// print "sending |$manfile| from |$seid| to |$deids[$i]|" ;
		$command="dtnsend -s " . $seid . " -d " . $deids[$i] . " -e " . $expiry . " -t f -p ". $procfile;
		$dtnsendoutput=system($command);
	}
}

print "Done manually processing $fullname\n";

